from xml.parsers import expat


def setup_parser(parser, handler):
    parser.ordered_attributes = True
    parser.buffer_text = True

    parser.ExternalEntityRefHandler = handler.externalEntityRef

    # store the parser in the handler so we can recurse
    handler.parser = parser


class _DictSAXHandler(object):
    def externalEntityRef(self, context, base, sysId, pubId):
        print(context, base, sysId, pubId)
        external_parser = self.parser.ExternalEntityParserCreate(context)
        print("%x, %x" % (id(self.parser), id(external_parser)))
        setup_parser(external_parser, self)
        f = open(sysId, 'rb')
        print(f)
        external_parser.ParseFile(f)
        print(f)

        # all OK
        return 1


def parse(xml_input, encoding=None):
    namespace_separator=':'

    handler = _DictSAXHandler()

    parser = expat.ParserCreate(
        encoding,
        namespace_separator
    )
    setup_parser(parser, handler)

    if hasattr(xml_input, 'read'):
        parser.ParseFile(xml_input)
    else:
        parser.Parse(xml_input, True)
    return handler.item


parse(open('test1.xml', 'rb'))
